/[gentoo-x86]/eclass/qt4-build.eclass
Gentoo

Diff of /eclass/qt4-build.eclass

Parent Directory Parent Directory | Revision Log Revision Log | View Patch Patch

Revision 1.108 Revision 1.161
1# Copyright 1999-2011 Gentoo Foundation 1# Copyright 1999-2015 Gentoo Foundation
2# Distributed under the terms of the GNU General Public License v2 2# Distributed under the terms of the GNU General Public License v2
3# $Header: /var/cvsroot/gentoo-x86/eclass/qt4-build.eclass,v 1.108 2011/12/25 18:49:52 pesa Exp $ 3# $Header: /var/cvsroot/gentoo-x86/eclass/qt4-build.eclass,v 1.161 2015/03/15 01:25:19 pesa Exp $
4 4
5# @ECLASS: qt4-build.eclass 5# @ECLASS: qt4-build.eclass
6# @MAINTAINER: 6# @MAINTAINER:
7# Qt herd <qt@gentoo.org> 7# Qt herd <qt@gentoo.org>
8# @BLURB: Eclass for Qt4 split ebuilds. 8# @BLURB: Eclass for Qt4 split ebuilds.
9# @DESCRIPTION: 9# @DESCRIPTION:
10# This eclass contains various functions that are used when building Qt4. 10# This eclass contains various functions that are used when building Qt4.
11 11
12inherit base eutils multilib toolchain-funcs flag-o-matic versionator 12case ${EAPI} in
13 4|5) : ;;
14 *) die "qt4-build.eclass: unsupported EAPI=${EAPI:-0}" ;;
15esac
13 16
14MY_PV=${PV/_/-} 17inherit eutils flag-o-matic multilib toolchain-funcs
15MY_P=qt-everywhere-opensource-src-${MY_PV}
16 18
17HOMEPAGE="http://qt.nokia.com/ http://qt-project.org/" 19HOMEPAGE="https://www.qt.io/ https://qt-project.org/"
18SRC_URI="http://get.qt.nokia.com/qt/source/${MY_P}.tar.gz"
19LICENSE="|| ( LGPL-2.1 GPL-3 )" 20LICENSE="|| ( LGPL-2.1 GPL-3 )"
21SLOT="4"
22
23case ${PV} in
24 4.?.9999)
25 QT4_BUILD_TYPE="live"
26 EGIT_REPO_URI=(
27 "git://gitorious.org/qt/qt.git"
28 "https://git.gitorious.org/qt/qt.git"
29 )
30 EGIT_BRANCH=${PV%.9999}
31 inherit git-r3
32 ;;
33 *)
34 QT4_BUILD_TYPE="release"
35 MY_P=qt-everywhere-opensource-src-${PV/_/-}
36 SRC_URI="http://download.qt.io/archive/qt/${PV%.*}/${PV}/${MY_P}.tar.gz"
37 S=${WORKDIR}/${MY_P}
38 ;;
39esac
20 40
21IUSE="aqua debug pch" 41IUSE="aqua debug pch"
42[[ ${PN} != qtxmlpatterns ]] && IUSE+=" +exceptions"
22 43
23[[ ${CATEGORY}/${PN} != x11-libs/qt-xmlpatterns ]] && 44DEPEND="virtual/pkgconfig"
24[[ ${CATEGORY}/${PN} != x11-themes/qgtkstyle ]] && 45if [[ ${QT4_BUILD_TYPE} == live ]]; then
25 IUSE+=" +exceptions" 46 DEPEND+=" dev-lang/perl"
26
27if version_is_at_least 4.7.99999999; then
28 IUSE+=" c++0x qpa"
29fi 47fi
30 48
31DEPEND="dev-util/pkgconfig"
32RDEPEND="
33 !<x11-libs/qt-assistant-${PV}
34 !>x11-libs/qt-assistant-${PV}-r9999
35 !<x11-libs/qt-core-${PV}
36 !>x11-libs/qt-core-${PV}-r9999
37 !<x11-libs/qt-dbus-${PV}
38 !>x11-libs/qt-dbus-${PV}-r9999
39 !<x11-libs/qt-declarative-${PV}
40 !>x11-libs/qt-declarative-${PV}-r9999
41 !<x11-libs/qt-demo-${PV}
42 !>x11-libs/qt-demo-${PV}-r9999
43 !<x11-libs/qt-gui-${PV}
44 !>x11-libs/qt-gui-${PV}-r9999
45 !<x11-libs/qt-multimedia-${PV}
46 !>x11-libs/qt-multimedia-${PV}-r9999
47 !<x11-libs/qt-opengl-${PV}
48 !>x11-libs/qt-opengl-${PV}-r9999
49 !<x11-libs/qt-phonon-${PV}
50 !>x11-libs/qt-phonon-${PV}-r9999
51 !<x11-libs/qt-qt3support-${PV}
52 !>x11-libs/qt-qt3support-${PV}-r9999
53 !<x11-libs/qt-script-${PV}
54 !>x11-libs/qt-script-${PV}-r9999
55 !<x11-libs/qt-sql-${PV}
56 !>x11-libs/qt-sql-${PV}-r9999
57 !<x11-libs/qt-svg-${PV}
58 !>x11-libs/qt-svg-${PV}-r9999
59 !<x11-libs/qt-test-${PV}
60 !>x11-libs/qt-test-${PV}-r9999
61 !<x11-libs/qt-webkit-${PV}
62 !>x11-libs/qt-webkit-${PV}-r9999
63 !<x11-libs/qt-xmlpatterns-${PV}
64 !>x11-libs/qt-xmlpatterns-${PV}-r9999
65"
66
67S=${WORKDIR}/${MY_P}
68
69# @FUNCTION: qt4-build_pkg_setup 49# @FUNCTION: qt4-build_pkg_setup
70# @DESCRIPTION: 50# @DESCRIPTION:
71# Sets up S, MY_P, PATH, and LD_LIBRARY_PATH 51# Sets up PATH and LD_LIBRARY_PATH.
72qt4-build_pkg_setup() { 52qt4-build_pkg_setup() {
73 [[ ${EAPI} == 2 ]] && use !prefix && EPREFIX= 53 # Warn users of possible breakage when downgrading to a previous release.
74
75 # Protect users by not allowing downgrades between releases
76 # Downgrading revisions within the same release should be allowed 54 # Downgrading revisions within the same release is safe.
77 if has_version '>'${CATEGORY}/${P}-r9999; then 55 if has_version ">${CATEGORY}/${P}-r9999:4"; then
78 if [[ -z ${I_KNOW_WHAT_I_AM_DOING} ]]; then 56 ewarn
79 eerror "Sanity check to keep you from breaking your system:"
80 eerror " Downgrading Qt is completely unsupported and will break your system!"
81 die "aborting to save your system"
82 else
83 ewarn "Downgrading Qt is completely unsupported and will break your system!" 57 ewarn "Downgrading Qt is completely unsupported and can break your system!"
84 fi 58 ewarn
85 fi
86
87 if [[ ${PN} == "qt-webkit" ]]; then
88 eshopts_push -s extglob
89 if is-flagq '-g?(gdb)?([1-9])'; then
90 echo
91 ewarn "You have enabled debug info (probably have -g or -ggdb in your \$C{,XX}FLAGS)."
92 ewarn "You may experience really long compilation times and/or increased memory usage."
93 ewarn "If compilation fails, please try removing -g{,gdb} before reporting a bug."
94 ewarn "For more info check out bug #307861"
95 echo
96 fi
97 eshopts_pop
98 fi 59 fi
99 60
100 PATH="${S}/bin${PATH:+:}${PATH}" 61 PATH="${S}/bin${PATH:+:}${PATH}"
101 if [[ ${CHOST} != *-darwin* ]]; then 62 if [[ ${CHOST} != *-darwin* ]]; then
102 LD_LIBRARY_PATH="${S}/lib${LD_LIBRARY_PATH:+:}${LD_LIBRARY_PATH}" 63 LD_LIBRARY_PATH="${S}/lib${LD_LIBRARY_PATH:+:}${LD_LIBRARY_PATH}"
107 # avoid extract failure. 68 # avoid extract failure.
108 [[ ${CHOST} == *-apple-darwin* ]] && \ 69 [[ ${CHOST} == *-apple-darwin* ]] && \
109 QT4_EXTRACT_DIRECTORIES="src/gui/kernel/qapplication_mac.mm 70 QT4_EXTRACT_DIRECTORIES="src/gui/kernel/qapplication_mac.mm
110 ${QT4_EXTRACT_DIRECTORIES}" 71 ${QT4_EXTRACT_DIRECTORIES}"
111 fi 72 fi
112
113 # Make sure ebuilds use the required EAPI
114 if [[ ${EAPI} != [23] ]]; then
115 eerror "The qt4-build eclass requires EAPI=2 or EAPI=3, but this ebuild is using"
116 eerror "EAPI=${EAPI:-0}. The ebuild author or editor failed. This ebuild needs to be"
117 eerror "fixed. Using qt4-build eclass without EAPI=2 or EAPI=3 will fail."
118 die "qt4-build eclass requires EAPI=2 or EAPI=3"
119 fi
120
121 if ! version_is_at_least 4.1 $(gcc-version); then
122 ewarn "Using a GCC version lower than 4.1 is not supported!"
123 fi
124} 73}
74
75# @ECLASS-VARIABLE: PATCHES
76# @DEFAULT_UNSET
77# @DESCRIPTION:
78# Array variable containing all the patches to be applied. This variable
79# is expected to be defined in the global scope of ebuilds. Make sure to
80# specify the full path. This variable is used in src_prepare phase.
81#
82# Example:
83# @CODE
84# PATCHES=(
85# "${FILESDIR}/mypatch.patch"
86# "${FILESDIR}/patches_folder/"
87# )
88# @CODE
89
90# @ECLASS-VARIABLE: QT4_EXTRACT_DIRECTORIES
91# @DEFAULT_UNSET
92# @DESCRIPTION:
93# Space-separated list of directories that will be extracted
94# from Qt tarball.
125 95
126# @ECLASS-VARIABLE: QT4_TARGET_DIRECTORIES 96# @ECLASS-VARIABLE: QT4_TARGET_DIRECTORIES
97# @DEFAULT_UNSET
127# @DESCRIPTION: 98# @DESCRIPTION:
128# Arguments for build_target_directories. Takes the directories, in which the 99# Space-separated list of directories that will be configured,
129# code should be compiled. This is a space-separated list 100# compiled, and installed. All paths must be relative to ${S}.
130
131# @ECLASS-VARIABLE: QT4_EXTRACT_DIRECTORIES
132# @DESCRIPTION:
133# Space separated list including the directories that will be extracted from Qt
134# tarball
135 101
136# @FUNCTION: qt4-build_src_unpack 102# @FUNCTION: qt4-build_src_unpack
137# @DESCRIPTION: 103# @DESCRIPTION:
138# Unpacks the sources 104# Unpacks the sources.
139qt4-build_src_unpack() { 105qt4-build_src_unpack() {
140 setqtenv 106 setqtenv
141 local unpack_p="${MY_P}" 107
142 case "${PV}" in 108 if [[ $(gcc-major-version) -lt 4 ]] || [[ $(gcc-major-version) -eq 4 && $(gcc-minor-version) -lt 4 ]]; then
143 4.8.0_*) 109 ewarn
144 unpack_p="qt-everywhere-opensource-src-${PV/_*}" 110 ewarn "Using a GCC version lower than 4.4 is not supported."
111 ewarn
112 fi
113
114 if [[ ${PN} == qtwebkit ]]; then
115 eshopts_push -s extglob
116 if is-flagq '-g?(gdb)?([1-9])'; then
117 ewarn
118 ewarn "You have enabled debug info (probably have -g or -ggdb in your CFLAGS/CXXFLAGS)."
119 ewarn "You may experience really long compilation times and/or increased memory usage."
120 ewarn "If compilation fails, please try removing -g/-ggdb before reporting a bug."
121 ewarn "For more info check out https://bugs.gentoo.org/307861"
122 ewarn
123 fi
124 eshopts_pop
125 fi
126
127 case ${QT4_BUILD_TYPE} in
128 live)
129 git-r3_src_unpack
145 ;; 130 ;;
131 release)
132 local tarball="${MY_P}.tar.gz" target= targets=
133 for target in configure LICENSE.GPL3 LICENSE.LGPL projects.pro \
134 src/{qbase,qt_targets,qt_install}.pri bin config.tests \
135 mkspecs qmake ${QT4_EXTRACT_DIRECTORIES}
136 do
137 targets+="${MY_P}/${target} "
138 done
139
140 ebegin "Unpacking parts of ${tarball}:" ${targets//${MY_P}\/}
141 tar -xzf "${DISTDIR}/${tarball}" ${targets}
142 eend $? || die "failed to unpack"
143 ;;
146 esac 144 esac
147 local target targets=
148 for target in configure LICENSE.GPL3 LICENSE.LGPL projects.pro \
149 src/{qbase,qt_targets,qt_install}.pri bin config.tests mkspecs qmake \
150 ${QT4_EXTRACT_DIRECTORIES}; do
151 targets+=" ${unpack_p}/${target}"
152 done
153
154 echo tar xzf "${DISTDIR}"/${MY_P}.tar.gz ${targets}
155 tar xzf "${DISTDIR}"/${MY_P}.tar.gz ${targets} || die
156 case "${PV}" in
157 4.8.0_*)
158 mv ${WORKDIR}/qt-everywhere-opensource-src-${PV/_*} \
159 ${WORKDIR}/qt-everywhere-opensource-src-${MY_PV}
160 ;;
161 esac
162} 145}
163
164# @ECLASS-VARIABLE: PATCHES
165# @DESCRIPTION:
166# In case you have patches to apply, specify them in PATCHES variable. Make sure
167# to specify the full path. This variable is necessary for src_prepare phase.
168# example:
169# PATCHES="${FILESDIR}"/mypatch.patch
170# ${FILESDIR}"/mypatch2.patch"
171#
172 146
173# @FUNCTION: qt4-build_src_prepare 147# @FUNCTION: qt4-build_src_prepare
174# @DESCRIPTION: 148# @DESCRIPTION:
175# Prepare the sources before the configure phase. Strip CFLAGS if necessary, and fix 149# Prepare the sources before the configure phase. Strip CFLAGS if necessary, and fix
176# source files in order to respect CFLAGS/CXXFLAGS/LDFLAGS specified on /etc/make.conf. 150# the build system in order to respect CFLAGS/CXXFLAGS/LDFLAGS specified in make.conf.
177qt4-build_src_prepare() { 151qt4-build_src_prepare() {
178 setqtenv 152 setqtenv
179 cd "${S}"
180 153
181 if version_is_at_least "4.7"; then 154 if [[ ${QT4_BUILD_TYPE} == live ]]; then
155 QTDIR="." ./bin/syncqt || die "syncqt failed"
156 fi
157
182 # fix libX11 dependency on non X packages 158 # avoid X11 dependency in non-gui packages
183 local nolibx11_pkgs="qt-core qt-dbus qt-script qt-sql qt-test qt-xmlpatterns" 159 local nolibx11_pkgs="qtbearer qtcore qtdbus qtscript qtsql qttest qtxmlpatterns"
184 has ${PN} ${nolibx11_pkgs} && qt_nolibx11 160 has ${PN} ${nolibx11_pkgs} && qt_nolibx11
185
186 qt_assistant_cleanup
187 fi
188 161
189 if use aqua; then 162 if use aqua; then
190 # provide a proper macx-g++-64 163 # provide a proper macx-g++-64
191 use x64-macos && ln -s macx-g++ mkspecs/$(qt_mkspecs_dir) 164 use x64-macos && ln -s macx-g++ mkspecs/$(qt_mkspecs_dir)
192 165
193 sed -e '/^CONFIG/s:app_bundle::' \ 166 sed -e '/^CONFIG/s:app_bundle::' \
194 -e '/^CONFIG/s:plugin_no_soname:plugin_with_soname absolute_library_soname:' \ 167 -e '/^CONFIG/s:plugin_no_soname:plugin_with_soname absolute_library_soname:' \
195 -i mkspecs/$(qt_mkspecs_dir)/qmake.conf || die "sed failed" 168 -i mkspecs/$(qt_mkspecs_dir)/qmake.conf || die
196 fi 169 fi
197 170
198 if [[ ${PN} != qt-core ]]; then 171 if [[ ${CATEGORY}/${PN} != dev-qt/qtcore ]]; then
199 skip_qmake_build 172 skip_qmake_build
200 skip_project_generation 173 skip_project_generation
201 symlink_binaries_to_buildtree 174 symlink_binaries_to_buildtree
202 fi 175 fi
203 176
204 if [[ ${CHOST} == *86*-apple-darwin* ]] ; then
205 # qmake bus errors with -O2 but -O3 works
206 replace-flags -O2 -O3
207 fi
208
209 # Bug 178652
210 if [[ $(gcc-major-version) == 3 ]] && use amd64; then
211 ewarn "Appending -fno-gcse to CFLAGS/CXXFLAGS"
212 append-flags -fno-gcse
213 fi
214
215 if use_if_iuse c++0x; then 177 if use_if_iuse c++0x; then
216 ewarn "You are about to build Qt4 using the C++11 standard. Even though"
217 ewarn "this is an official standard, some of the reverse dependencies"
218 ewarn "may fail to compile or link againt the Qt4 libraries. Before"
219 ewarn "reporting a bug, make sure your bug is reproducible with c++0x"
220 ewarn "disabled."
221 append-flags -std=c++0x 178 append-cxxflags -std=c++0x
222 fi
223
224 # Unsupported old gcc versions - hardened needs this :(
225 if [[ $(gcc-major-version) -lt 4 ]] ; then
226 ewarn "Appending -fno-stack-protector to CXXFLAGS"
227 append-cxxflags -fno-stack-protector
228 # Bug 253127
229 sed -e "/^QMAKE_CFLAGS\t/ s:$: -fno-stack-protector-all:" \
230 -i "${S}"/mkspecs/common/g++.conf || die "sed ${S}/mkspecs/common/g++.conf failed"
231 fi 179 fi
232 180
233 # Bug 261632 181 # Bug 261632
234 if use ppc64; then 182 if use ppc64; then
235 ewarn "Appending -mminimal-toc to CFLAGS/CXXFLAGS"
236 append-flags -mminimal-toc 183 append-flags -mminimal-toc
237 fi 184 fi
238 185
239 # Bug 282984 && Bug 295530 186 # Bug 373061
240 sed -e "s:\(^SYSTEM_VARIABLES\):CC=\"$(tc-getCC)\"\nCXX=\"$(tc-getCXX)\"\nCFLAGS=\"${CFLAGS}\"\nCXXFLAGS=\"${CXXFLAGS}\"\nLDFLAGS=\"${LDFLAGS}\"\n\1:" \ 187 # qmake bus errors with -O2 or -O3 but -O1 works
241 -i configure || die "sed qmake compilers failed" 188 if [[ ${CHOST} == *86*-apple-darwin* ]]; then
242 189 replace-flags -O[23] -O1
243 # Bug 321335
244 if version_is_at_least 4.6; then
245 find ./config.tests/unix -name "*.test" -type f -exec grep -lZ \$MAKE '{}' \; | \
246 xargs -0 \
247 sed -e "s:\(\$MAKE\):\1 CC=\"$(tc-getCC)\" CXX=\"$(tc-getCXX)\" LD=\"$(tc-getCXX)\" LINK=\"$(tc-getCXX)\":g" \
248 -i || die "sed test compilers failed"
249 fi 190 fi
191
192 # Bug 417105
193 # graphite on gcc 4.7 causes miscompilations
194 if [[ $(gcc-version) == "4.7" ]]; then
195 filter-flags -fgraphite-identity
196 fi
197
198 # Respect CC, CXX, {C,CXX,LD}FLAGS in .qmake.cache
199 sed -e "/^SYSTEM_VARIABLES=/i \
200 CC='$(tc-getCC)'\n\
201 CXX='$(tc-getCXX)'\n\
202 CFLAGS='${CFLAGS}'\n\
203 CXXFLAGS='${CXXFLAGS}'\n\
204 LDFLAGS='${LDFLAGS}'\n\
205 QMakeVar set QMAKE_CFLAGS_RELEASE\n\
206 QMakeVar set QMAKE_CFLAGS_DEBUG\n\
207 QMakeVar set QMAKE_CXXFLAGS_RELEASE\n\
208 QMakeVar set QMAKE_CXXFLAGS_DEBUG\n\
209 QMakeVar set QMAKE_LFLAGS_RELEASE\n\
210 QMakeVar set QMAKE_LFLAGS_DEBUG\n"\
211 -i configure \
212 || die "sed SYSTEM_VARIABLES failed"
213
214 # Respect CC, CXX, LINK and *FLAGS in config.tests
215 find config.tests/unix -name '*.test' -type f -print0 | xargs -0 \
216 sed -i -e "/bin\/qmake/ s: \"\$SRCDIR/: \
217 'QMAKE_CC=$(tc-getCC)' 'QMAKE_CXX=$(tc-getCXX)' 'QMAKE_LINK=$(tc-getCXX)' \
218 'QMAKE_CFLAGS+=${CFLAGS}' 'QMAKE_CXXFLAGS+=${CXXFLAGS}' 'QMAKE_LFLAGS+=${LDFLAGS}'&:" \
219 || die "sed config.tests failed"
250 220
251 # Bug 172219 221 # Bug 172219
252 sed -e "s:X11R6/::" \ 222 sed -e 's:/X11R6/:/:' -i mkspecs/$(qt_mkspecs_dir)/qmake.conf || die
253 -i "${S}"/mkspecs/$(qt_mkspecs_dir)/qmake.conf || die "sed ${S}/mkspecs/$(qt_mkspecs_dir)/qmake.conf failed"
254 223
255 if [[ ${CHOST} == *-darwin* ]]; then 224 if [[ ${CHOST} == *-darwin* ]]; then
256 # Set FLAGS *and* remove -arch, since our gcc-apple is multilib 225 # Set FLAGS *and* remove -arch, since our gcc-apple is multilib
257 # crippled (by design) :/ 226 # crippled (by design) :/
227 local mac_gpp_conf=
228 if [[ -f mkspecs/common/mac-g++.conf ]]; then
229 # qt < 4.8 has mac-g++.conf
230 mac_gpp_conf="mkspecs/common/mac-g++.conf"
231 elif [[ -f mkspecs/common/g++-macx.conf ]]; then
232 # qt >= 4.8 has g++-macx.conf
233 mac_gpp_conf="mkspecs/common/g++-macx.conf"
234 else
235 die "no known conf file for mac found"
236 fi
237 sed \
258 sed -e "s:QMAKE_CFLAGS_RELEASE.*=.*:QMAKE_CFLAGS_RELEASE=${CFLAGS}:" \ 238 -e "s:QMAKE_CFLAGS_RELEASE.*=.*:QMAKE_CFLAGS_RELEASE=${CFLAGS}:" \
259 -e "s:QMAKE_CXXFLAGS_RELEASE.*=.*:QMAKE_CXXFLAGS_RELEASE=${CXXFLAGS}:" \ 239 -e "s:QMAKE_CXXFLAGS_RELEASE.*=.*:QMAKE_CXXFLAGS_RELEASE=${CXXFLAGS}:" \
260 -e "s:QMAKE_LFLAGS_RELEASE.*=.*:QMAKE_LFLAGS_RELEASE=-headerpad_max_install_names ${LDFLAGS}:" \ 240 -e "s:QMAKE_LFLAGS_RELEASE.*=.*:QMAKE_LFLAGS_RELEASE=-headerpad_max_install_names ${LDFLAGS}:" \
261 -e "s:-arch\s\w*::g" \ 241 -e "s:-arch\s\w*::g" \
262 -i mkspecs/common/mac-g++.conf || die "sed mkspecs/common/mac-g++.conf failed" 242 -i ${mac_gpp_conf} \
243 || die "sed ${mac_gpp_conf} failed"
263 244
264 # Fix configure's -arch settings that appear in qmake/Makefile and also 245 # Fix configure's -arch settings that appear in qmake/Makefile and also
265 # fix arch handling (automagically duplicates our -arch arg and breaks 246 # fix arch handling (automagically duplicates our -arch arg and breaks
266 # pch). Additionally disable Xarch support. 247 # pch). Additionally disable Xarch support.
248 local mac_gcc_confs="${mac_gpp_conf}"
249 if [[ -f mkspecs/common/gcc-base-macx.conf ]]; then
250 mac_gcc_confs+=" mkspecs/common/gcc-base-macx.conf"
251 fi
267 sed \ 252 sed \
268 -e "s:-arch i386::" \ 253 -e "s:-arch i386::" \
269 -e "s:-arch ppc::" \ 254 -e "s:-arch ppc::" \
270 -e "s:-arch x86_64::" \ 255 -e "s:-arch x86_64::" \
271 -e "s:-arch ppc64::" \ 256 -e "s:-arch ppc64::" \
272 -e "s:-arch \$i::" \ 257 -e "s:-arch \$i::" \
273 -e "/if \[ ! -z \"\$NATIVE_64_ARCH\" \]; then/,/fi/ d" \ 258 -e "/if \[ ! -z \"\$NATIVE_64_ARCH\" \]; then/,/fi/ d" \
274 -e "s:CFG_MAC_XARCH=yes:CFG_MAC_XARCH=no:g" \ 259 -e "s:CFG_MAC_XARCH=yes:CFG_MAC_XARCH=no:g" \
275 -e "s:-Xarch_x86_64::g" \ 260 -e "s:-Xarch_x86_64::g" \
276 -e "s:-Xarch_ppc64::g" \ 261 -e "s:-Xarch_ppc64::g" \
277 -i configure mkspecs/common/mac-g++.conf || die "sed configure failed" 262 -i configure ${mac_gcc_confs} \
263 || die "sed -arch/-Xarch failed"
278 264
279 # On Snow Leopard don't fall back to 10.5 deployment target. 265 # On Snow Leopard don't fall back to 10.5 deployment target.
280 if [[ ${CHOST} == *-apple-darwin10 ]] ; then 266 if [[ ${CHOST} == *-apple-darwin10 ]]; then
281 sed -e "s:QMakeVar set QMAKE_MACOSX_DEPLOYMENT_TARGET.*:QMakeVar set QMAKE_MACOSX_DEPLOYMENT_TARGET 10.6:g" \ 267 sed -e "s:QMakeVar set QMAKE_MACOSX_DEPLOYMENT_TARGET.*:QMakeVar set QMAKE_MACOSX_DEPLOYMENT_TARGET 10.6:g" \
282 -e "s:-mmacosx-version-min=10.[0-9]:-mmacosx-version-min=10.6:g" \ 268 -e "s:-mmacosx-version-min=10.[0-9]:-mmacosx-version-min=10.6:g" \
283 -i configure mkspecs/common/mac-g++.conf || die "sed configure failed" 269 -i configure ${mac_gpp_conf} \
270 || die "sed deployment target failed"
284 fi 271 fi
285 fi 272 fi
286 273
287 # this one is needed for all systems with a separate -liconv, apart from 274 # this one is needed for all systems with a separate -liconv, apart from
288 # Darwin, for which the sources already cater for -liconv 275 # Darwin, for which the sources already cater for -liconv
289 if use !elibc_glibc && [[ ${CHOST} != *-darwin* ]] ; then 276 if use !elibc_glibc && [[ ${CHOST} != *-darwin* ]]; then
290 sed \ 277 sed -e 's|mac:\(LIBS += -liconv\)|\1|g' \
291 -e "s|mac:LIBS += -liconv|LIBS += -liconv|g" \
292 -i config.tests/unix/iconv/iconv.pro \ 278 -i config.tests/unix/iconv/iconv.pro \
293 || die "sed on iconv.pro failed" 279 || die "sed iconv.pro failed"
294 fi 280 fi
295 281
296 # we need some patches for Solaris 282 # we need some patches for Solaris
297 sed -i \
298 -e '/^QMAKE_LFLAGS_THREAD/a\QMAKE_LFLAGS_DYNAMIC_LIST = -Wl,--dynamic-list,' \ 283 sed -i -e '/^QMAKE_LFLAGS_THREAD/a\QMAKE_LFLAGS_DYNAMIC_LIST = -Wl,--dynamic-list,' \
299 mkspecs/$(qt_mkspecs_dir)/qmake.conf || die 284 mkspecs/$(qt_mkspecs_dir)/qmake.conf || die
300 # use GCC over SunStudio 285 # use GCC over SunStudio
301 sed -i -e '/PLATFORM=solaris-cc/s/cc/g++/' configure || die 286 sed -i -e '/PLATFORM=solaris-cc/s/cc/g++/' configure || die
302 # don't flirt with non-Prefix stuff, we're quite possessive 287 # do not flirt with non-Prefix stuff, we're quite possessive
303 sed -i -e '/^QMAKE_\(LIB\|INC\)DIR\(_X11\|_OPENGL\|\)\t/s/=.*$/=/' \ 288 sed -i -e '/^QMAKE_\(LIB\|INC\)DIR\(_X11\|_OPENGL\|\)\t/s/=.*$/=/' \
304 mkspecs/$(qt_mkspecs_dir)/qmake.conf || die 289 mkspecs/$(qt_mkspecs_dir)/qmake.conf || die
305 # strip predefined CFLAGS from qmake ( bug #312689 )
306 sed -i '/^QMAKE_CFLAGS_RELEASE/s:+=.*:+=:' mkspecs/common/g++.conf
307 290
308 base_src_prepare 291 # apply patches
292 [[ -n ${PATCHES[@]} ]] && epatch "${PATCHES[@]}"
293 epatch_user
309} 294}
310 295
311# @FUNCTION: qt4-build_src_configure 296# @FUNCTION: qt4-build_src_configure
312# @DESCRIPTION: 297# @DESCRIPTION:
313# Default configure phase 298# Default configure phase
314qt4-build_src_configure() { 299qt4-build_src_configure() {
315 setqtenv 300 setqtenv
316 myconf="$(standard_configure_options) ${myconf}"
317 301
318 # this one is needed for all systems with a separate -liconv, apart from 302 local conf="
319 # Darwin, for which the sources already cater for -liconv 303 -prefix ${QTPREFIXDIR}
320 use !elibc_glibc && [[ ${CHOST} != *-darwin* ]] && \ 304 -bindir ${QTBINDIR}
321 myconf+=" -liconv" 305 -libdir ${QTLIBDIR}
306 -docdir ${QTDOCDIR}
307 -headerdir ${QTHEADERDIR}
308 -plugindir ${QTPLUGINDIR}
309 -importdir ${QTIMPORTDIR}
310 -datadir ${QTDATADIR}
311 -translationdir ${QTTRANSDIR}
312 -sysconfdir ${QTSYSCONFDIR}
313 -examplesdir ${QTEXAMPLESDIR}
314 -demosdir ${QTDEMOSDIR}
315 -opensource -confirm-license
316 -shared -fast -largefile -stl -verbose
317 -nomake examples -nomake demos"
322 318
323 if use_if_iuse glib; then 319 # ARCH is set on Gentoo. Qt now falls back to generic on an unsupported
324 # use -I, -L and -l from configure 320 # $(tc-arch). Therefore we convert it to supported values.
325 local glibflags="$(pkg-config --cflags --libs glib-2.0 gthread-2.0)" 321 case "$(tc-arch)" in
326 # avoid the -pthread argument 322 amd64|x64-*) conf+=" -arch x86_64" ;;
327 myconf+=" ${glibflags//-pthread}" 323 ppc-macos) conf+=" -arch ppc" ;;
328 unset glibflags 324 ppc|ppc64|ppc-*) conf+=" -arch powerpc" ;;
329 fi 325 sparc|sparc-*|sparc64-*) conf+=" -arch sparc" ;;
326 x86-macos) conf+=" -arch x86" ;;
327 x86|x86-*) conf+=" -arch i386" ;;
328 alpha|arm|ia64|mips|s390) conf+=" -arch $(tc-arch)" ;;
329 arm64|hppa|sh) conf+=" -arch generic" ;;
330 *) die "$(tc-arch) is unsupported by this eclass. Please file a bug." ;;
331 esac
330 332
331 if use_if_iuse qpa; then 333 conf+=" -platform $(qt_mkspecs_dir)"
332 ewarn
333 ewarn "The qpa useflag enables the Qt Platform Abstraction, formely"
334 ewarn "known as Qt Lighthouse. If you are not sure what that is, then"
335 ewarn "disable it before reporting any bugs related to this useflag."
336 ewarn
337 myconf+=" -qpa"
338 fi
339 334
340 if use aqua ; then
341 # On (snow) leopard use the new (frameworked) cocoa code.
342 if [[ ${CHOST##*-darwin} -ge 9 ]] ; then
343 myconf+=" -cocoa -framework"
344
345 # We are crazy and build cocoa + qt3support :-)
346 if use qt3support; then
347 sed -e "/case \"\$PLATFORM,\$CFG_MAC_COCOA\" in/,/;;/ s|CFG_QT3SUPPORT=\"no\"|CFG_QT3SUPPORT=\"yes\"|" \
348 -i configure
349 fi
350
351 # We need the source's headers, not the installed ones.
352 myconf+=" -I${S}/include"
353
354 # Add hint for the framework location.
355 myconf+=" -F${QTLIBDIR}"
356 fi
357 else
358 # freetype2 include dir is non-standard, thus include it on configure
359 # use -I from configure
360 myconf+=" $(pkg-config --cflags freetype2)"
361 fi
362
363 echo ./configure ${myconf}
364 ./configure ${myconf} || die "./configure failed"
365 myconf=""
366
367 prepare_directories ${QT4_TARGET_DIRECTORIES}
368}
369
370# @FUNCTION: qt4-build_src_compile
371# @DESCRIPTION:
372# Actual compile phase
373qt4-build_src_compile() {
374 setqtenv
375
376 build_directories ${QT4_TARGET_DIRECTORIES}
377}
378
379# @FUNCTION: qt4-build_src_test
380# @DESCRIPTION:
381# Runs tests only in target directories.
382qt4-build_src_test() {
383 for dir in ${QT4_TARGET_DIRECTORIES}; do
384 emake -j1 check -C ${dir}
385 done
386}
387
388# @FUNCTION: fix_includes
389# @DESCRIPTION:
390# For MacOSX we need to add some symlinks when frameworks are
391# being used, to avoid complications with some more or less stupid packages.
392fix_includes() {
393 if use aqua && [[ ${CHOST##*-darwin} -ge 9 ]] ; then
394 # Some packages tend to include <Qt/...>
395 dodir "${QTHEADERDIR#${EPREFIX}}"/Qt
396
397 # Fake normal headers when frameworks are installed... eases life later on
398 local dest f
399 for frw in "${D}${QTLIBDIR}"/*.framework; do
400 [[ -e "${frw}"/Headers ]] || continue
401 f=$(basename ${frw})
402 dest="${QTHEADERDIR#${EPREFIX}}"/${f%.framework}
403 dosym "${QTLIBDIR#${EPREFIX}}"/${f}/Headers "${dest}"
404
405 # Link normal headers as well.
406 for hdr in "${D}/${QTLIBDIR}/${f}"/Headers/*; do
407 h=$(basename ${hdr})
408 dosym "${QTLIBDIR#${EPREFIX}}"/${f}/Headers/${h} "${QTHEADERDIR#${EPREFIX}}"/Qt/${h}
409 done
410 done
411 fi
412}
413
414# @FUNCTION: qt4-build_src_install
415# @DESCRIPTION:
416# Perform the actual installation including some library fixes.
417qt4-build_src_install() {
418 [[ ${EAPI} == 2 ]] && use !prefix && ED=${D}
419 setqtenv
420
421 install_directories ${QT4_TARGET_DIRECTORIES}
422 install_qconfigs
423 fix_library_files
424 fix_includes
425
426 # remove .la files since we are building only shared Qt libraries
427 find "${D}"${QTLIBDIR} -name "*.la" -print0 | xargs -0 rm
428}
429
430# @FUNCTION: setqtenv
431setqtenv() {
432 # Set up installation directories
433 QTBASEDIR=${EPREFIX}/usr/$(get_libdir)/qt4
434 QTPREFIXDIR=${EPREFIX}/usr
435 QTBINDIR=${EPREFIX}/usr/bin
436 QTLIBDIR=${EPREFIX}/usr/$(get_libdir)/qt4
437 QMAKE_LIBDIR_QT=${QTLIBDIR}
438 QTPCDIR=${EPREFIX}/usr/$(get_libdir)/pkgconfig
439 QTDATADIR=${EPREFIX}/usr/share/qt4
440 QTDOCDIR=${EPREFIX}/usr/share/doc/qt-${PV}
441 QTHEADERDIR=${EPREFIX}/usr/include/qt4
442 QTPLUGINDIR=${QTLIBDIR}/plugins
443 QTIMPORTDIR=${QTLIBDIR}/imports
444 QTSYSCONFDIR=${EPREFIX}/etc/qt4
445 QTTRANSDIR=${QTDATADIR}/translations
446 QTEXAMPLESDIR=${QTDATADIR}/examples
447 QTDEMOSDIR=${QTDATADIR}/demos
448 QT_INSTALL_PREFIX=${EPREFIX}/usr/$(get_libdir)/qt4
449 PLATFORM=$(qt_mkspecs_dir)
450
451 unset QMAKESPEC
452}
453
454# @FUNCTION: standard_configure_options
455# @DESCRIPTION:
456# Sets up some standard configure options, like libdir (if necessary), whether
457# debug info is wanted or not.
458standard_configure_options() {
459 local myconf="-prefix ${QTPREFIXDIR} -bindir ${QTBINDIR} -libdir ${QTLIBDIR}
460 -docdir ${QTDOCDIR} -headerdir ${QTHEADERDIR} -plugindir ${QTPLUGINDIR}
461 -importdir ${QTIMPORTDIR} -datadir ${QTDATADIR} -translationdir ${QTTRANSDIR}
462 -sysconfdir ${QTSYSCONFDIR} -examplesdir ${QTEXAMPLESDIR} -demosdir ${QTDEMOSDIR}
463 -opensource -confirm-license -shared -fast -largefile -stl -verbose
464 -platform $(qt_mkspecs_dir) -nomake examples -nomake demos"
465
466 [[ $(get_libdir) != lib ]] && myconf+=" -L${EPREFIX}/usr/$(get_libdir)" 335 [[ $(get_libdir) != lib ]] && conf+=" -L${EPREFIX}/usr/$(get_libdir)"
467 336
468 # debug/release 337 # debug/release
469 if use debug; then 338 if use debug; then
470 myconf+=" -debug" 339 conf+=" -debug"
471 else 340 else
472 myconf+=" -release" 341 conf+=" -release"
473 fi 342 fi
474 myconf+=" -no-separate-debug-info" 343 conf+=" -no-separate-debug-info"
475 344
476 # exceptions USE flag 345 # exceptions USE flag
477 local exceptions="-exceptions" 346 conf+=" $(in_iuse exceptions && qt_use exceptions || echo -exceptions)"
478 in_iuse exceptions && exceptions="$(qt_use exceptions)"
479 myconf+=" ${exceptions}"
480 347
481 # disable RPATH on Qt >= 4.8 (bug 380415) 348 # disable rpath (bug 380415), except on prefix (bug 417169)
482 version_is_at_least 4.8 && myconf+=" -no-rpath" 349 use prefix || conf+=" -no-rpath"
483 350
484 # precompiled headers don't work on hardened, where the flag is masked 351 # precompiled headers don't work on hardened, where the flag is masked
485 myconf+=" $(qt_use pch)" 352 conf+=" $(qt_use pch)"
486 353
487 # -reduce-relocations 354 # -reduce-relocations
488 # This flag seems to introduce major breakage to applications, 355 # This flag seems to introduce major breakage to applications,
489 # mostly to be seen as a core dump with the message "QPixmap: Must 356 # mostly to be seen as a core dump with the message "QPixmap: Must
490 # construct a QApplication before a QPaintDevice" on Solaris. 357 # construct a QApplication before a QPaintDevice" on Solaris.
491 # -- Daniel Vergien 358 # -- Daniel Vergien
492 [[ ${CHOST} != *-solaris* ]] && myconf+=" -reduce-relocations" 359 [[ ${CHOST} != *-solaris* ]] && conf+=" -reduce-relocations"
493 360
494 use aqua && myconf+=" -no-framework" 361 # this one is needed for all systems with a separate -liconv, apart from
362 # Darwin, for which the sources already cater for -liconv
363 if use !elibc_glibc && [[ ${CHOST} != *-darwin* ]]; then
364 conf+=" -liconv"
365 fi
495 366
496 # ARCH is set on Gentoo. Qt now falls back to generic on an unsupported 367 if use_if_iuse glib; then
497 # $(tc-arch). Therefore we convert it to supported values. 368 local glibflags="$(pkg-config --cflags --libs glib-2.0 gthread-2.0)"
498 case "$(tc-arch)" in 369 # avoid the -pthread argument
499 amd64|x64-*) myconf+=" -arch x86_64" ;; 370 conf+=" ${glibflags//-pthread}"
500 ppc-macos) myconf+=" -arch ppc" ;; 371 unset glibflags
501 ppc|ppc64|ppc-*) myconf+=" -arch powerpc" ;; 372 fi
502 sparc|sparc-*|sparc64-*) myconf+=" -arch sparc" ;;
503 x86-macos) myconf+=" -arch x86" ;;
504 x86|x86-*) myconf+=" -arch i386" ;;
505 alpha|arm|ia64|mips|s390) myconf+=" -arch $(tc-arch)" ;;
506 hppa|sh) myconf+=" -arch generic" ;;
507 *) die "$(tc-arch) is unsupported by this eclass. Please file a bug." ;;
508 esac
509 373
374 if use aqua; then
375 # On (snow) leopard use the new (frameworked) cocoa code.
376 if [[ ${CHOST##*-darwin} -ge 9 ]]; then
377 conf+=" -cocoa -framework"
378 # We need the source's headers, not the installed ones.
379 conf+=" -I${S}/include"
380 # Add hint for the framework location.
381 conf+=" -F${QTLIBDIR}"
382
383 # We are crazy and build cocoa + qt3support :-)
384 if use qt3support; then
385 sed -e "/case \"\$PLATFORM,\$CFG_MAC_COCOA\" in/,/;;/ s|CFG_QT3SUPPORT=\"no\"|CFG_QT3SUPPORT=\"yes\"|" \
386 -i configure || die
387 fi
388 else
389 conf+=" -no-framework"
390 fi
391 else
392 # freetype2 include dir is non-standard, thus pass it to configure
393 conf+=" $(pkg-config --cflags-only-I freetype2)"
394 fi
395
510 echo "${myconf}" 396 conf+=" ${myconf}"
397 myconf=
398
399 echo ./configure ${conf}
400 ./configure ${conf} || die "./configure failed"
401
402 prepare_directories ${QT4_TARGET_DIRECTORIES}
403}
404
405# @FUNCTION: qt4-build_src_compile
406# @DESCRIPTION:
407# Actual compile phase
408qt4-build_src_compile() {
409 setqtenv
410
411 build_directories ${QT4_TARGET_DIRECTORIES}
412}
413
414# @FUNCTION: qt4-build_src_test
415# @DESCRIPTION:
416# Runs tests only in target directories.
417qt4-build_src_test() {
418 # QtMultimedia does not have any test suite (bug #332299)
419 [[ ${CATEGORY}/${PN} == dev-qt/qtmultimedia ]] && return
420
421 for dir in ${QT4_TARGET_DIRECTORIES}; do
422 emake -j1 check -C ${dir}
423 done
424}
425
426# @FUNCTION: fix_includes
427# @DESCRIPTION:
428# For MacOS X we need to add some symlinks when frameworks are
429# being used, to avoid complications with some more or less stupid packages.
430fix_includes() {
431 if use aqua && [[ ${CHOST##*-darwin} -ge 9 ]]; then
432 local frw dest f h rdir
433 # Some packages tend to include <Qt/...>
434 dodir "${QTHEADERDIR#${EPREFIX}}"/Qt
435
436 # Fake normal headers when frameworks are installed... eases life later
437 # on, make sure we use relative links though, as some ebuilds assume
438 # these dirs exist in src_install to add additional files
439 f=${QTHEADERDIR}
440 h=${QTLIBDIR}
441 while [[ -n ${f} && ${f%%/*} == ${h%%/*} ]] ; do
442 f=${f#*/}
443 h=${h#*/}
444 done
445 rdir=${h}
446 f="../"
447 while [[ ${h} == */* ]] ; do
448 f="${f}../"
449 h=${h#*/}
450 done
451 rdir="${f}${rdir}"
452
453 for frw in "${D}${QTLIBDIR}"/*.framework; do
454 [[ -e "${frw}"/Headers ]] || continue
455 f=$(basename ${frw})
456 dest="${QTHEADERDIR#${EPREFIX}}"/${f%.framework}
457 dosym "${rdir}"/${f}/Headers "${dest}"
458
459 # Link normal headers as well.
460 for hdr in "${D}/${QTLIBDIR}/${f}"/Headers/*; do
461 h=$(basename ${hdr})
462 dosym "../${rdir}"/${f}/Headers/${h} \
463 "${QTHEADERDIR#${EPREFIX}}"/Qt/${h}
464 done
465 done
466 fi
467}
468
469# @FUNCTION: qt4-build_src_install
470# @DESCRIPTION:
471# Perform the actual installation including some library fixes.
472qt4-build_src_install() {
473 setqtenv
474
475 install_directories ${QT4_TARGET_DIRECTORIES}
476 install_qconfigs
477 fix_library_files
478 fix_includes
479
480 # remove .la files since we are building only shared libraries
481 prune_libtool_files
482}
483
484# @FUNCTION: setqtenv
485# @INTERNAL
486setqtenv() {
487 # Set up installation directories
488 QTPREFIXDIR=${EPREFIX}/usr
489 QTBINDIR=${QTPREFIXDIR}/bin
490 QTLIBDIR=${QTPREFIXDIR}/$(get_libdir)/qt4
491 QTPCDIR=${QTPREFIXDIR}/$(get_libdir)/pkgconfig
492 QTDOCDIR=${QTPREFIXDIR}/share/doc/qt-${PV}
493 QTHEADERDIR=${QTPREFIXDIR}/include/qt4
494 QTPLUGINDIR=${QTLIBDIR}/plugins
495 QTIMPORTDIR=${QTLIBDIR}/imports
496 QTDATADIR=${QTPREFIXDIR}/share/qt4
497 QTTRANSDIR=${QTDATADIR}/translations
498 QTSYSCONFDIR=${EPREFIX}/etc/qt4
499 QTEXAMPLESDIR=${QTDATADIR}/examples
500 QTDEMOSDIR=${QTDATADIR}/demos
501 QMAKE_LIBDIR_QT=${QTLIBDIR}
502
503 PLATFORM=$(qt_mkspecs_dir)
504 unset QMAKESPEC
505
506 export XDG_CONFIG_HOME="${T}"
511} 507}
512 508
513# @FUNCTION: prepare_directories 509# @FUNCTION: prepare_directories
514# @USAGE: < directories > 510# @USAGE: < directories >
511# @INTERNAL
515# @DESCRIPTION: 512# @DESCRIPTION:
516# Generates makefiles for the directories set in $QT4_TARGET_DIRECTORIES 513# Generates Makefiles for the given list of directories.
517prepare_directories() { 514prepare_directories() {
518 for x in "$@"; do 515 for x in "$@"; do
519 pushd "${S}"/${x} >/dev/null 516 pushd "${S}"/${x} >/dev/null || die
520 einfo "Running qmake in: ${x}" 517 einfo "Running qmake in: ${x}"
521 # avoid running over the maximum argument number, bug #299810 518 "${S}"/bin/qmake \
522 { 519 "LIBS+=-L${QTLIBDIR}" \
523 echo "${S}"/mkspecs/common/*.conf 520 "CONFIG+=nostrip" \
524 find "${S}" -name '*.pr[io]' 521 || die "qmake failed"
525 } | xargs sed -i \
526 -e "s:\$\$\[QT_INSTALL_LIBS\]:${QTLIBDIR}:g" \
527 -e "s:\$\$\[QT_INSTALL_PLUGINS\]:${QTPLUGINDIR}:g" \
528 || die
529 "${S}"/bin/qmake "LIBS+=-L${QTLIBDIR}" "CONFIG+=nostrip" || die "qmake failed"
530 popd >/dev/null 522 popd >/dev/null || die
531 done 523 done
532} 524}
533
534 525
535# @FUNCTION: build_directories 526# @FUNCTION: build_directories
536# @USAGE: < directories > 527# @USAGE: < directories >
528# @INTERNAL
537# @DESCRIPTION: 529# @DESCRIPTION:
538# Compiles the code in $QT4_TARGET_DIRECTORIES 530# Compiles the code in the given list of directories.
539build_directories() { 531build_directories() {
540 for x in "$@"; do 532 for x in "$@"; do
541 pushd "${S}"/${x} >/dev/null 533 pushd "${S}"/${x} >/dev/null || die
534 emake \
535 AR="$(tc-getAR) cqs" \
542 emake CC="$(tc-getCC)" \ 536 CC="$(tc-getCC)" \
543 CXX="$(tc-getCXX)" \ 537 CXX="$(tc-getCXX)" \
544 LINK="$(tc-getCXX)" || die "emake failed" 538 LINK="$(tc-getCXX)" \
539 RANLIB=":" \
540 STRIP=":"
545 popd >/dev/null 541 popd >/dev/null || die
546 done 542 done
547} 543}
548 544
549# @FUNCTION: install_directories 545# @FUNCTION: install_directories
550# @USAGE: < directories > 546# @USAGE: < directories >
547# @INTERNAL
551# @DESCRIPTION: 548# @DESCRIPTION:
552# run emake install in the given directories, which are separated by spaces 549# Runs emake install in the given directories, which are separated by spaces.
553install_directories() { 550install_directories() {
554 for x in "$@"; do 551 for x in "$@"; do
555 pushd "${S}"/${x} >/dev/null || die "Can't pushd ${S}/${x}" 552 pushd "${S}"/${x} >/dev/null || die
556 emake INSTALL_ROOT="${D}" install || die "emake install failed" 553 emake INSTALL_ROOT="${D}" install
557 popd >/dev/null || die "Can't popd from ${S}/${x}" 554 popd >/dev/null || die
558 done 555 done
559} 556}
560 557
561# @ECLASS-VARIABLE: QCONFIG_ADD 558# @ECLASS-VARIABLE: QCONFIG_ADD
562# @DESCRIPTION: 559# @DESCRIPTION:
572# @DESCRIPTION: 569# @DESCRIPTION:
573# List variables that should be defined at the top of QtCore/qconfig.h 570# List variables that should be defined at the top of QtCore/qconfig.h
574: ${QCONFIG_DEFINE:=} 571: ${QCONFIG_DEFINE:=}
575 572
576# @FUNCTION: install_qconfigs 573# @FUNCTION: install_qconfigs
574# @INTERNAL
577# @DESCRIPTION: 575# @DESCRIPTION:
578# Install gentoo-specific mkspecs configurations 576# Install gentoo-specific mkspecs configurations.
579install_qconfigs() { 577install_qconfigs() {
580 local x 578 local x
581 if [[ -n ${QCONFIG_ADD} || -n ${QCONFIG_REMOVE} ]]; then 579 if [[ -n ${QCONFIG_ADD} || -n ${QCONFIG_REMOVE} ]]; then
582 for x in QCONFIG_ADD QCONFIG_REMOVE; do 580 for x in QCONFIG_ADD QCONFIG_REMOVE; do
583 [[ -n ${!x} ]] && echo ${x}=${!x} >> "${T}"/${PN}-qconfig.pri 581 [[ -n ${!x} ]] && echo ${x}=${!x} >> "${T}"/${PN}-qconfig.pri
584 done 582 done
585 insinto ${QTDATADIR#${EPREFIX}}/mkspecs/gentoo 583 insinto ${QTDATADIR#${EPREFIX}}/mkspecs/gentoo
586 doins "${T}"/${PN}-qconfig.pri || die "installing ${PN}-qconfig.pri failed" 584 doins "${T}"/${PN}-qconfig.pri
587 fi 585 fi
588 586
589 if [[ -n ${QCONFIG_DEFINE} ]]; then 587 if [[ -n ${QCONFIG_DEFINE} ]]; then
590 for x in ${QCONFIG_DEFINE}; do 588 for x in ${QCONFIG_DEFINE}; do
591 echo "#define ${x}" >> "${T}"/gentoo-${PN}-qconfig.h 589 echo "#define ${x}" >> "${T}"/gentoo-${PN}-qconfig.h
592 done 590 done
593 insinto ${QTHEADERDIR#${EPREFIX}}/Gentoo 591 insinto ${QTHEADERDIR#${EPREFIX}}/Gentoo
594 doins "${T}"/gentoo-${PN}-qconfig.h || die "installing ${PN}-qconfig.h failed" 592 doins "${T}"/gentoo-${PN}-qconfig.h
595 fi 593 fi
596} 594}
597 595
598# @FUNCTION: generate_qconfigs 596# @FUNCTION: generate_qconfigs
597# @INTERNAL
599# @DESCRIPTION: 598# @DESCRIPTION:
600# Generates gentoo-specific configurations 599# Generates gentoo-specific qconfig.{h,pri}.
601generate_qconfigs() { 600generate_qconfigs() {
602 if [[ -n ${QCONFIG_ADD} || -n ${QCONFIG_REMOVE} || -n ${QCONFIG_DEFINE} || ${CATEGORY}/${PN} == x11-libs/qt-core ]]; then 601 if [[ -n ${QCONFIG_ADD} || -n ${QCONFIG_REMOVE} || -n ${QCONFIG_DEFINE} || ${CATEGORY}/${PN} == dev-qt/qtcore ]]; then
603 local x qconfig_add qconfig_remove qconfig_new 602 local x qconfig_add qconfig_remove qconfig_new
604 for x in "${ROOT}${QTDATADIR}"/mkspecs/gentoo/*-qconfig.pri; do 603 for x in "${ROOT}${QTDATADIR}"/mkspecs/gentoo/*-qconfig.pri; do
605 [[ -f ${x} ]] || continue 604 [[ -f ${x} ]] || continue
606 qconfig_add+=" $(sed -n 's/^QCONFIG_ADD=//p' "${x}")" 605 qconfig_add+=" $(sed -n 's/^QCONFIG_ADD=//p' "${x}")"
607 qconfig_remove+=" $(sed -n 's/^QCONFIG_REMOVE=//p' "${x}")" 606 qconfig_remove+=" $(sed -n 's/^QCONFIG_REMOVE=//p' "${x}")"
608 done 607 done
609 608
610 # these error checks do not use die because dying in pkg_post{inst,rm} 609 # these error checks do not use die because dying in pkg_post{inst,rm}
611 # just makes things worse. 610 # just makes things worse.
612 if [[ -e "${ROOT}${QTDATADIR}"/mkspecs/gentoo/qconfig.pri ]]; then 611 if [[ -e "${ROOT}${QTDATADIR}"/mkspecs/gentoo/qconfig.pri ]]; then
613 # start with the qconfig.pri that qt-core installed 612 # start with the qconfig.pri that qtcore installed
614 if ! cp "${ROOT}${QTDATADIR}"/mkspecs/gentoo/qconfig.pri \ 613 if ! cp "${ROOT}${QTDATADIR}"/mkspecs/gentoo/qconfig.pri \
615 "${ROOT}${QTDATADIR}"/mkspecs/qconfig.pri; then 614 "${ROOT}${QTDATADIR}"/mkspecs/qconfig.pri; then
616 eerror "cp qconfig failed." 615 eerror "cp qconfig failed."
617 return 1 616 return 1
618 fi 617 fi
654 fi 653 fi
655} 654}
656 655
657# @FUNCTION: qt4-build_pkg_postrm 656# @FUNCTION: qt4-build_pkg_postrm
658# @DESCRIPTION: 657# @DESCRIPTION:
659# Generate configurations when the package is completely removed 658# Regenerate configuration when the package is completely removed.
660qt4-build_pkg_postrm() { 659qt4-build_pkg_postrm() {
661 generate_qconfigs 660 generate_qconfigs
662} 661}
663 662
664# @FUNCTION: qt4-build_pkg_postinst 663# @FUNCTION: qt4-build_pkg_postinst
665# @DESCRIPTION: 664# @DESCRIPTION:
666# Generate configuration, plus throws a message about possible 665# Regenerate configuration, plus throw a message about possible
667# breakages and proposed solutions. 666# breakages and proposed solutions.
668qt4-build_pkg_postinst() { 667qt4-build_pkg_postinst() {
669 generate_qconfigs 668 generate_qconfigs
670} 669}
671 670
672# @FUNCTION: skip_qmake_build 671# @FUNCTION: skip_qmake_build
672# @INTERNAL
673# @DESCRIPTION: 673# @DESCRIPTION:
674# Don't need to build qmake, as it's already installed from qt-core 674# Patches configure to skip qmake compilation, as it's already installed by qtcore.
675skip_qmake_build() { 675skip_qmake_build() {
676 # Don't need to build qmake, as it's already installed from qt-core
677 sed -i -e "s:if true:if false:g" "${S}"/configure || die "sed failed" 676 sed -i -e "s:if true:if false:g" "${S}"/configure || die
678} 677}
679 678
680# @FUNCTION: skip_project_generation 679# @FUNCTION: skip_project_generation
680# @INTERNAL
681# @DESCRIPTION: 681# @DESCRIPTION:
682# Exit the script early by throwing in an exit before all of the .pro files are scanned 682# Exit the script early by throwing in an exit before all of the .pro files are scanned.
683skip_project_generation() { 683skip_project_generation() {
684 # Exit the script early by throwing in an exit before all of the .pro files are scanned
685 sed -e "s:echo \"Finding:exit 0\n\necho \"Finding:g" \ 684 sed -i -e "s:echo \"Finding:exit 0\n\necho \"Finding:g" "${S}"/configure || die
686 -i "${S}"/configure || die "sed failed"
687} 685}
688 686
689# @FUNCTION: symlink_binaries_to_buildtree 687# @FUNCTION: symlink_binaries_to_buildtree
688# @INTERNAL
690# @DESCRIPTION: 689# @DESCRIPTION:
691# Symlink generated binaries to buildtree so they can be used during compilation 690# Symlinks generated binaries to buildtree, so they can be used during compilation time.
692# time
693symlink_binaries_to_buildtree() { 691symlink_binaries_to_buildtree() {
694 for bin in qmake moc uic rcc; do 692 for bin in qmake moc uic rcc; do
695 ln -s "${QTBINDIR}"/${bin} "${S}"/bin/ || die "symlinking ${bin} to ${S}/bin failed" 693 ln -s "${QTBINDIR}"/${bin} "${S}"/bin/ || die "symlinking ${bin} to ${S}/bin failed"
696 done 694 done
697} 695}
698 696
699# @FUNCTION: fix_library_files 697# @FUNCTION: fix_library_files
698# @INTERNAL
700# @DESCRIPTION: 699# @DESCRIPTION:
701# Fixes the pathes in *.la, *.prl, *.pc, as they are wrong due to sandbox and 700# Fixes the paths in *.la, *.prl, *.pc, as they are wrong due to sandbox and
702# moves the *.pc-files into the pkgconfig directory 701# moves the *.pc files into the pkgconfig directory.
703fix_library_files() { 702fix_library_files() {
703 local libfile
704 for libfile in "${D}"/${QTLIBDIR}/{*.la,*.prl,pkgconfig/*.pc}; do 704 for libfile in "${D}"/${QTLIBDIR}/{*.la,*.prl,pkgconfig/*.pc}; do
705 if [[ -e ${libfile} ]]; then 705 if [[ -e ${libfile} ]]; then
706 sed -i -e "s:${S}/lib:${QTLIBDIR}:g" ${libfile} || die "sed on ${libfile} failed" 706 sed -i -e "s:${S}/lib:${QTLIBDIR}:g" ${libfile} || die "sed on ${libfile} failed"
707 fi 707 fi
708 done 708 done
709 709
710 # pkgconfig files refer to WORKDIR/bin as the moc and uic locations. Fix: 710 # pkgconfig files refer to WORKDIR/bin as the moc and uic locations
711 for libfile in "${D}"/${QTLIBDIR}/pkgconfig/*.pc; do 711 for libfile in "${D}"/${QTLIBDIR}/pkgconfig/*.pc; do
712 if [[ -e ${libfile} ]]; then 712 if [[ -e ${libfile} ]]; then
713 sed -i -e "s:${S}/bin:${QTBINDIR}:g" ${libfile} || die "sed failed" 713 sed -i -e "s:${S}/bin:${QTBINDIR}:g" ${libfile} || die "sed on ${libfile} failed"
714 714
715 # Move .pc files into the pkgconfig directory 715 # Move .pc files into the pkgconfig directory
716 dodir ${QTPCDIR#${EPREFIX}} 716 dodir ${QTPCDIR#${EPREFIX}}
717 mv ${libfile} "${D}"/${QTPCDIR}/ \ 717 mv ${libfile} "${D}"/${QTPCDIR}/ || die "moving ${libfile} to ${D}/${QTPCDIR}/ failed"
718 || die "moving ${libfile} to ${D}/${QTPCDIR}/ failed"
719 fi 718 fi
720 done 719 done
721 720
722 # Don't install an empty directory 721 # Don't install an empty directory
723 rmdir "${D}"/${QTLIBDIR}/pkgconfig 722 rmdir "${D}"/${QTLIBDIR}/pkgconfig
724} 723}
725 724
726# @FUNCTION: qt_use 725# @FUNCTION: qt_use
727# @USAGE: < flag > [ feature ] [ enableval ] 726# @USAGE: < flag > [ feature ] [ enableval ]
728# @DESCRIPTION: 727# @DESCRIPTION:
729# This will echo "${enableval}-${feature}" if <flag> is enabled, or 728# This will echo "-${enableval}-${feature}" if <flag> is enabled, or
730# "-no-${feature} if the flag is disabled. If [feature] is not specified <flag> 729# "-no-${feature}" if it's disabled. If [feature] is not specified, <flag>
731# will be used for that. If [enableval] is not specified, it omits the 730# will be used for that. If [enableval] is not specified, it omits the
732# assignment-part 731# "-${enableval}" part.
733qt_use() { 732qt_use() {
734 local flag=$1 733 use "$1" && echo "${3:+-$3}-${2:-$1}" || echo "-no-${2:-$1}"
735 local feature=$1
736 local enableval=
737
738 [[ -n $2 ]] && feature=$2
739 [[ -n $3 ]] && enableval=-$3
740
741 if use ${flag}; then
742 echo "${enableval}-${feature}"
743 else
744 echo "-no-${feature}"
745 fi
746} 734}
747 735
748# @FUNCTION: qt_mkspecs_dir 736# @FUNCTION: qt_mkspecs_dir
749# @RETURN: the specs-directory w/o path 737# @RETURN: the specs-directory w/o path
750# @DESCRIPTION: 738# @DESCRIPTION:
751# Allows us to define which mkspecs dir we want to use. 739# Allows us to define which mkspecs dir we want to use.
752qt_mkspecs_dir() { 740qt_mkspecs_dir() {
753 # Allows us to define which mkspecs dir we want to use.
754 local spec 741 local spec=
755 742
756 case ${CHOST} in 743 case "${CHOST}" in
757 *-freebsd*|*-dragonfly*) 744 *-freebsd*|*-dragonfly*)
758 spec=freebsd ;; 745 spec=freebsd ;;
759 *-openbsd*) 746 *-openbsd*)
760 spec=openbsd ;; 747 spec=openbsd ;;
761 *-netbsd*) 748 *-netbsd*)
772 *-solaris*) 759 *-solaris*)
773 spec=solaris ;; 760 spec=solaris ;;
774 *-linux-*|*-linux) 761 *-linux-*|*-linux)
775 spec=linux ;; 762 spec=linux ;;
776 *) 763 *)
777 die "Unknown CHOST, no platform chosen" 764 die "${FUNCNAME}(): Unknown CHOST '${CHOST}'" ;;
778 esac 765 esac
779 766
780 CXX=$(tc-getCXX) 767 case "$(tc-getCXX)" in
781 if [[ ${CXX} == *g++* ]]; then 768 *g++*)
782 spec+=-g++ 769 spec+=-g++ ;;
783 elif [[ ${CXX} == *icpc* ]]; then 770 *icpc*)
784 spec+=-icc 771 spec+=-icc ;;
785 else 772 *)
786 die "Unknown compiler '${CXX}'" 773 die "${FUNCNAME}(): Unknown compiler '$(tc-getCXX)'" ;;
787 fi 774 esac
788 if [[ -n ${LIBDIR/lib} ]]; then
789 spec+=-${LIBDIR/lib}
790 fi
791 775
792 # Add -64 for 64bit profiles 776 # Add -64 for 64bit profiles
793 if use x64-freebsd || 777 if use x64-freebsd ||
794 use amd64-linux || 778 use amd64-linux ||
795 use x64-macos || 779 use x64-macos ||
800 fi 784 fi
801 785
802 echo "${spec}" 786 echo "${spec}"
803} 787}
804 788
805# @FUNCTION: qt_assistant_cleanup
806# @RETURN: nothing
807# @DESCRIPTION:
808# Tries to clean up tools.pro for qt-assistant ebuilds.
809# Meant to be called in src_prepare().
810# Since Qt 4.7.4 this function is a no-op.
811qt_assistant_cleanup() {
812 # apply patching to qt-assistant ebuilds only
813 [[ ${PN} != "qt-assistant" ]] && return
814
815 # no longer needed for 4.7.4 and later
816 version_is_at_least "4.7.4" && return
817
818 # different versions (and branches...) may need different handling,
819 # add a case if you need special handling
820 case "${MY_PV_EXTRA}" in
821 *kde-qt*)
822 sed -e "/^[ \t]*porting/,/^[ \t]*win32.*activeqt$/d" \
823 -e "/mac/,/^embedded.*makeqpf$/d" \
824 -i tools/tools.pro || die "patching tools.pro failed"
825 ;;
826 *)
827 sed -e "/^[ \t]*porting/,/^[ \t]*win32.*activeqt$/d" \
828 -e "/mac/,/^embedded.*makeqpf$/d" \
829 -e "s/^\([ \t]*pixeltool\) /\1 qdoc3 /" \
830 -i tools/tools.pro || die "patching tools.pro failed"
831 ;;
832 esac
833}
834
835# @FUNCTION: qt_nolibx11 789# @FUNCTION: qt_nolibx11
836# @RETURN: nothing 790# @INTERNAL
837# @DESCRIPTION: 791# @DESCRIPTION:
838# Ignore X11 tests for packages that don't need X libraries installed 792# Skip X11 tests for packages that don't need X libraries installed.
839qt_nolibx11() { 793qt_nolibx11() {
840 einfo "Removing X11 check to allow X-less compilation" 794 sed -i -e '/^if.*PLATFORM_X11.*CFG_GUI/,/^fi$/d' "${S}"/configure || die
841 sed -i "/unixtests\/compile.test.*config.tests\/x11\/xlib/,/fi$/d" "${S}"/configure ||
842 die "x11 check sed failed"
843} 795}
844 796
845EXPORT_FUNCTIONS pkg_setup src_unpack src_prepare src_configure src_compile src_install src_test pkg_postrm pkg_postinst 797EXPORT_FUNCTIONS pkg_setup src_unpack src_prepare src_configure src_compile src_install src_test pkg_postrm pkg_postinst

Legend:
Removed from v.1.108  
changed lines
  Added in v.1.161

  ViewVC Help
Powered by ViewVC 1.1.20